//+------------------------------------------------------------------+
//|                                                                  |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net/"

#property indicator_separate_window
#property indicator_minimum -100
#property indicator_maximum 100
#property indicator_buffers 4
#property indicator_color1 LimeGreen
#property indicator_color2 OrangeRed
#property indicator_color3 LimeGreen
#property indicator_color4 OrangeRed
//---- indicator parameters
extern int minBars=0;
extern int minSize=50;
extern int minBars2=5;
extern int minSize2=25;
extern int nBars=300;
//---- indicator buffers
double ExtMapBuffer1[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double ExtMapBuffer5[];
double ExtMapBuffer6[];
double zz[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorBuffers(6);
//---- drawing settings
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0,119);
   SetIndexBuffer(0,ExtMapBuffer3);
   SetIndexEmptyValue(0,0.0);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1,119);
   SetIndexBuffer(1,ExtMapBuffer4);
   SetIndexEmptyValue(1,0.0);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,ExtMapBuffer5);
   SetIndexEmptyValue(2,0.0);
   SetIndexStyle(3,DRAW_LINE);
   SetIndexBuffer(3,ExtMapBuffer6);
   SetIndexEmptyValue(3,0.0);
//---- indicator buffers mapping
   SetIndexBuffer(4,ExtMapBuffer1);
   SetIndexBuffer(5,zz);
//---- indicator short name
//   IndicatorShortName("ZigZag("+ExtDepth+","+ExtDeviation+","+ExtBackstep+")");
//---- initialization done
   return(0);
  }
int deinit()
  {
//----       
   return(0);
  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
   int shift;
   bool signal;
   if(nBars>Bars || nBars==0) nBars=Bars;
   ArrayInitialize(ExtMapBuffer1,0.0);
   ArrayInitialize(ExtMapBuffer3,0.0);
   ArrayInitialize(ExtMapBuffer4,0.0);
   ArrayInitialize(ExtMapBuffer5,0.0);
   ArrayInitialize(ExtMapBuffer6,0.0);
   ArrayInitialize(zz,0.0); 
   for(shift=nBars-1; shift>=0; shift--) 
    {
     ExtMapBuffer1[shift]=iCustom(NULL,0,"ZZ_Ensign_2",minBars,minSize,minBars2,minSize2,0,shift);
     if(ExtMapBuffer1[shift]==Low[shift]) signal=true;
     if(ExtMapBuffer1[shift]==High[shift]) signal=false;
     if (signal) zz[shift]=-1;
     else zz[shift]=1;
    } 
   for(shift=nBars-4; shift>=0; shift--)
     {
      if (zz[shift]<0) 
        {

         if (zz[shift+2]>0)
           {
            if (zz[shift+1]>0)
              {
               ExtMapBuffer4[shift+1]=-70;
               ExtMapBuffer6[shift+1]=-70;
               ExtMapBuffer4[shift]=-90;
               ExtMapBuffer6[shift]=-90;
               ExtMapBuffer3[shift]=-90;
               ExtMapBuffer5[shift]=-90;
              }
            else
              {
               ExtMapBuffer3[shift]=-30;
               ExtMapBuffer5[shift]=-30;
              }
           }
         else
           {
            if (zz[shift+1]>0)
              {
               ExtMapBuffer3[shift]=-90;
               ExtMapBuffer5[shift]=-90;
               ExtMapBuffer4[shift]=-90;
               ExtMapBuffer6[shift]=-90;
              }
            else
              {
               ExtMapBuffer3[shift]=0.001;
               ExtMapBuffer5[shift]=0.001;
              }
           }

        }
      else 
        {
         if (zz[shift+2]>0)
           {
            if (zz[shift+1]>0)
              {
               ExtMapBuffer4[shift]=0.001;
               ExtMapBuffer6[shift]=0.001;
              }
            else
              {
               ExtMapBuffer3[shift]=90;
               ExtMapBuffer5[shift]=90;
               ExtMapBuffer4[shift]=90;
               ExtMapBuffer6[shift]=90;
              }
           }
         else
           {
            if (zz[shift+1]>0)
              {
               ExtMapBuffer4[shift]=30;
               ExtMapBuffer6[shift]=30;
              }
            else
              {
               ExtMapBuffer3[shift+1]=70;
               ExtMapBuffer5[shift+1]=70;
               ExtMapBuffer3[shift]=90;
               ExtMapBuffer5[shift]=90;
               ExtMapBuffer4[shift]=90;
               ExtMapBuffer6[shift]=90;
              }
           }
        }

     }
   return(0); 
  }
//+------------------------------------------------------------------+  